cseg      segment para public 'CODE'
          assume   cs:cseg,ds:cseg,ss:cseg,es:cseg
          org      100h     ;end of program segment prefix
enter:    jmp      main     ;skip over data
himess    db  'CHKPIC.COM version 1.00',13,10
          db  'Copyright 1987 by Keith P. Graham',13,10,'$'
handle    dw  0
infile    db  81 dup(0)
;
;      MAC HEADER
;

MAC_HDR_SIZE   DW      640
MAC_VERSION    DB      0
MAC_LEN_FN     DB      6
MAC_FILE_NAME  DB      'OPTIKS'
               DB      57 DUP(0)
MAC_FILE_TYPE  DB      'PNTG'
MAC_FILE_CREAT DB      'MPNT'
MAC_FLAGS      DB      1
MAC_FILL1      DB      0
MAC_VERT       DW      0
MAC_HORIZ      DW      8001H
MAC_FOLDER     DW      0
MAC_PROT       DB      0
MAC_FILL2      DB      0
MAC_FORK       DD      0
MAC_R_FORK     DD      0
MAC_CRT_DATE   DB      9BH,41H,8CH,0FAH
MAC_LST_MOD    DB      9BH,41H,8CH,0FEH
MAC_FILL3      DB      27 DUP(0)
MAC_OS         DW      0
; mac body starts here
MAC_REV        DB      0,0,0,2
mac_fill       db      508 dup(0)
;
emess1   db  'Bad or missing file name',13,10,'$'
emess1a  db  'File not found',13,10,'$'
emess2   db  'Error opening file',13,10,'$'
emess3   db  'Error reading header or file too small',13,10,'$'
emess4   db  'Unrecognizable file header',13,10,'$'
mess1    db  'This is a MAC file, but the binary header is missing',13,10,'$'
mess2    db  'Mac header found, name is: '
pname    db  10  dup(0),13,10,'$'
mess3    db  'Probably a Mac file, but binary header is zeroes',13,10,'$'
mess4    db  13,10,10,'Job Complete'
crlf    db 13,10,'$'
mess5    db  'Looks like a Microsoft Paint file',13,10,'$'
mess6    db  'This might be a GEM paint file',13,10,'$'
mess7    db  'This must be an RLE file',13,10,'$'
mess8    db  'Looks like a ZSOFT PC Paintbrush file',13,10,'$'
mess9    db  7,'This is an OPTIKS file',13,10,'$'
mess10   db  'This is a CGA basic BLOAD/BSAVE file',13,10,'$'
mess11   db  'This just might be Datacopy WIPS file',13,10,'$'
mess12   db  'This could be a PC PAINT 1.50 PIC file',13,10,'$'
mess13   db  'This could be a PC PAINT 2.00 PIC file',13,10,'$'
mess14   db  'Could this be an IBM ISF file? I doubt it.',13,10,'$'
mactype  db  0
filesi   dw  0
MSP        DB     'DanM'
gem        db     0,1,0,8
RLE        Db     27,'G'
PCB        db     0ah,02,01
PCR        Db     'KPG'
bas        db     0fdh
           DW     0b800h
DCOPY      DW     0FFFFH
PIC        DB     0FEH
           DW     0B800H
PC2        DW     1234H
ISF        db     70h
other_types  proc  near
; check for other types
        lea    dx,mess5
        mov    cx,4
        lea    di,msp
        call   compare_head
        jc     check_gem
        ret
check_gem:
        lea    dx,mess6
        mov    cx,4
        lea    di,gem
        call   compare_head
        jc     check_rle
        ret
check_rle:
        lea    dx,mess7
        mov    cx,2
        lea    di,rle
        call   compare_head
        jc     check_pcb
        ret
check_pcb:
        lea    dx,mess8
        mov    cx,3
        lea    di,pcb
        call   compare_head
        jc     check_pcr
        ret
check_pcr:
        lea    dx,mess9
        mov    cx,3
        lea    di,pcr
        call   compare_head
        jc     check_bas
        ret
check_bas:
        lea    dx,mess10
        mov    cx,4
        lea    di,bas
        call   compare_head
        jc     check_dcopy
        ret
check_dcopy:
        lea    dx,mess11
        mov    cx,2
        lea    di,dcopy
        call   compare_head
        jc     check_pic
        ret
check_pic:
        lea    dx,mess12
        mov    cx,3
        lea    di,pic
        call   compare_head
        jc     check_pc2
        ret
check_pc2:
        lea    dx,mess13
        mov    cx,2
        lea    di,pc2
        call   compare_head
        jc     check_isf
        ret
check_isf:
        lea    dx,mess14
        cmp    mac_version,70h
        jne    check_another
        mov    bl,mac_version+1
        mov    bh,0
        add    bx,2
        cmp    byte ptr mac_version[bx],91h
        jne    check_another
        clc
        ret
check_another:
        stc
        ret
compare_head:
        lea    si,mac_version
        cld
rep     cmpsb
        je     got_match
        stc
        ret
got_match:
        clc
        ret
other_types  endp
main      proc     near
        lea    dx,himess
        mov    ah,9
        int    21h
        call   parse_name
        jnc    good_parse
        lea    dx,emess1
        jmp    end_check
good_parse:
        call   check_dir
        call   get_first
        jnc    top_loop
        lea    dx,emess1a
        jmp    end_check
top_loop:
        call   open_file
        jnc    ok_open
        lea    dx,emess2
        jmp    end_check0
ok_open:
        mov    cx,128
        lea    dx,mac_version
        call   read_file
        jnc    good_128
        lea    dx,emess3
        jmp    end_check0
good_128:
        call   mac_check
        jnc    its_a_mac
        call   other_types
        jnc    end_check0
        lea    dx,emess4
        jmp    end_check0
its_a_mac:
        lea     dx,mess1
        cmp     mactype,0
        je      end_check0
        lea     dx,mess3
        cmp     mactype,2
        je      end_check0
        lea     si,mac_file_name
        lea     di,pname
        mov     cx,10
rep     movsb
        lea     dx,mess2
end_check0:
        mov    ah,9
        int    21h
        call   close_file
; see if its time to end
        call   get_next
        jnc    good_next
        lea    dx,mess4
        jmp    end_check
good_next:
        jmp    top_loop
end_check:
        mov    ah,9
        int    21h
        call   close_file
        int    20h
;
get_first:
; finds the first guy
        mov    ah,4eh
        lea    dx,infile
        mov    cx,0h
        int    21h
        jnc    got_next
        stc
        ret
get_next:
        mov    ah,4fh
        int    21h
        jnc    got_next
        stc
        ret
got_next:
; here we have a guy at offset 158
        mov     si,158
        mov     di,filesi
        mov     cx,13
        cld
rep    movsb
; now to print the guy
        lea     di,infile
        mov     al,0
        mov     cx,80
        cld
repne   scasb
        lea     cx,infile
        sub     cx,di
        neg     cx
        dec     cx
        lea     dx,infile
        mov     bx,1
        mov     ah,40h
        int     21h
        lea     dx,crlf
        mov     ah,9
        int     21h
        clc
        ret
check_dir:
; this scans the infile for signs of a subdirectory and
; remembers where the last backslash was found
        lea   si,infile
        mov   cx,80
        mov   filesi,si
cd_loop:
        lodsb
        cmp   al,0
        je    end_cd
        cmp   al,'\'
        je    cd_slash
        cmp   al,':'
        je    cd_slash
        jmp   cd_loope
cd_slash:
        mov   filesi,si
cd_loope:
        loop  cd_loop
end_cd:
       ret
parse_name:
; gets filename into infile
        mov   cl,byte ptr ds:[80h]
        mov   ch,0
        cmp   cx,1
        jg    parse1
        stc
        ret
parse1:
        mov   si,81h
        lea   di,infile
parse2:
        lodsb
        cmp   al,13
        jne   parse3
        stc
        ret
parse3:
        cmp  al,' '
        je   parse4
        jmp  parse5
parse4:
        loop  parse2
        stc
        ret
parse5:
        stosb
parse6:
        lodsb
        cmp   al,13
        je    parse7
        cmp   al,' '
        je    parse7
        cmp   al,'/'
        je    parse7
        stosb
        loop  parse6
parse7:
        mov   al,0
        stosb
; now its time to see if the file type must be added
        mov   cx,di
        dec   cx
        lea   di,infile
        sub   cx,di
        mov   al,'.'
repne   scasb
        jne   no_dot
        clc
        ret
no_dot:
        stosb
        mov   ax,'AM'
        stosw
        mov   al,'C'
        mov   ah,0
        stosw
        clc
        ret
open_file:
; opens file in "infile"
          lea   dx,infile
          mov   al,0
          mov   ah,3dh
          int   21h
          jc    bad_open
          mov   handle,ax
          ret
bad_open:
          stc
          ret
close_file:
          mov   ah,3eh
          mov   bx,handle
          int   21h
          ret
read_file:
; reads in cx bytes into dx
         mov   ah,3fh
         mov   bx,handle
         int   21h
         jc    bad_read
         cmp   ax,cx
         jne   bad_read
         clc
         ret
bad_read:
         stc
         ret
mac_check:
;
; we will put the stuff for checking out the file here
; have to check and see what kind of thingy we got, we read in 128
; bytes, but we may have to read in either 384 more or 512 mode
;
; check to see if we have a binary zero header guy
             mov  mactype,0
             lea  di,mac_version+2
             mov  cx,64
             mov  al,0
             cld
repe  scasb
             jne  mac_check_more
             mov  mactype,2
             jmp  zero_head
mac_check_more:
; check for macbinary header
;
            cmp   mac_version,1
            jg    check_mp
            cmp   mac_file_name,'A'
            jl    check_mp
            cmp   mac_file_name,'z'
            jg    check_mp
            cmp   mac_file_type,'z'
            jg    check_mp
            cmp   mac_file_type,'A'
            jl    check_mp
            cmp   word ptr mac_r_fork,0
            jne   check_mp
            cmp   word ptr mac_r_fork+2,0
            jne   check_mp
            mov   mactype,1
zero_head:
; it looks like we got the macbinary header assume that there
; is a 512 macpaint header
            mov   cx,512
            lea   dx,mac_rev
            call  read_file
            ret
check_mp:
            cmp   byte ptr mac_version,0
            jne   bad_mac
            cmp   byte ptr mac_version+1,0
            jne   bad_mac
            cmp   byte ptr mac_version+2,0
            jne   bad_mac
            cmp   byte ptr mac_version+3,5
            jg    bad_mac
            cmp   byte ptr mac_version+3,0
            jl    bad_mac
            mov   cx,384
            lea   dx,mac_rev
            call  read_file
            ret
bad_mac:
            stc
            RET
;
          int      20h      ; back to dos
main      endp
cseg      ends
          end      enter
