; OKCIRC1 draws a circ on the screen
; the program is called from OKRANGE and is passed
; scol,srow,spoint
; rcol,rrow,rpoint
; ecol,erow    ; upper left of screen
dseg  segment para public 'DATA'
assume cs:cseg,ds:dseg,es:dseg
extrn  sx:word,sy:word,spnt:word    ; these are passed
extrn  ex:word,ey:word,epnt:word    ;
extrn ecol:word,erow:word,work_seg:word,maxlines:word
extrn fx:word,fy:word,colori:word,punch:byte,colors:byte
extrn vid_wid:word,vid_len:word,vbuffer:word,interlace:word
extrn debug:byte,vwid:word,siloc:word,appl_sw:byte
extrn linew:word,mode:byte
extrn cline:word
;
;  LOCAL DATA
;
tao   dw  0
taoh  dw  0  ; high word
xradius dw 0
yradius dw 0
xsquar  dw 0   ; contains x squared
ysquar  dw 0   ; contains y squared
xsquarh dw 0   ; contains x squared high word
ysquarh dw 0   ; contains y squared high word
x     dw  0 ; current absolute value of x
xp    dw  0 ; current point calue of x
y     dw  0 ; current absolut value of 0
;
t1    dw  0 ; current adder for goin in y direction
t2    dw  0 ; current adder for going in x direction
t1h   dw  0 ; current adder for goin in y direction    high word
t2h   dw  0 ; current adder for going in x direction   high word
;
vx  dw 0  ; used by color routines
;
color db 128,64,32,16,8,4,2,1,0
;
vesx   dw 0
;
dseg  ends
;
;
cseg  segment para public 'CODE'
assume cs:cseg,ds:dseg,es:dseg
extrn reset_segs:near,get_curr_seg:near
extrn calc_bank:near
put_dot  dw  0
;
xor_circr:
public xor_circr
       call  reset_segs
       lea   ax,cs:do_point
       mov   cs:put_dot,ax
       jmp   no_debug
xor_circs:
public xor_circs
       call  reset_segs
       lea   ax,dot_do
       mov   cs:put_dot,ax
       mov   ax,vbuffer
       mov   es,ax
       cmp   debug,9
       jne   no_debug
       int   3 ; debug break
no_debug:
; calc the rrow and rcol and rpoint
; sx,sy,spnt are the center of the circle
; ex,ey,epnt are the current finger point
; we have to calculate a few things
; calculate original x and y
;
      mov  ax,ey
      sub  ax,sy
      cmp  ax,0
      jg   ok_absy
      jne  neg_absy
      ret
neg_absy:
      neg  ax
ok_absy:
     mov  yradius,ax
     mov  y,ax         ; y is where we are
; get the length of x the same way
      mov  ax,ex
      sub  ax,sx
      mov  bx,epnt
      sub  bx,spnt
      cmp  ax,0
      jg   ok_absx
neg_absx:
      neg  ax
      neg  bx
ok_absx:
      mov  cx,ax
      shl  cx,1
      shl  cx,1
      shl  cx,1
      add  cx,bx
      cmp  cx,0
      jg   okpax
      jl   okpax1
      mov  ax,0
      clc
      ret
okpax1:
      neg  cx
okpax:
     mov  xradius,cx   ; cx is radius in x direction
     mov  x,0
     mov  xp,0
; x,y have the starting dot

; set up some squars
; x radius stuff
     mov ax,xradius
     mul xradius
     mov  xsquar,ax
     mov  xsquarh,dx
     mov  bx,dx
     mov  cx,yradius
     dec  cx
     mul  cx
     mov  t1,0
     mov  t1h,0
     sub  t1,ax
     sbb  t1h,dx
     mov  ax,bx
     mul  cx
     sub  t1h,ax
; yradius stuf
     mov ax,yradius
     mul yradius
     mov  ysquar,ax
     mov  ysquarh,dx
     mov  t2,ax
     mov  t2h,dx
;
;
; this is a try at a circle loop
      mov  tao,0
      mov  taoh,0
c_loop0:
      call cs:[put_dot]
      mov  ax,tao
      mov  bx,taoh
      mov  cx,ax
      mov  dx,bx
      mov  si,ax
      mov  di,bx
;
      add  cx,t1   ;r1
      adc  dx,t1h
;
      add  si,t2   ;r2
      adc  di,t2h
;
      add  ax,t1   ;r1
      adc  bx,t1h
      add  ax,t2   ; + r2
      adc  bx,t2h
;
      cmp  bx,0
      jge  tr0_gt
      neg  ax
      inc  bx
      neg  bx
tr0_gt:
      cmp  dx,0
      jge  tr1_gt
      neg  cx
      inc  dx
      neg  dx
tr1_gt:
      cmp  di,0
      jge  tr2_gt
      neg  si
      inc  di
      neg  di
tr2_gt:
      cmp  bx,dx
      jg   r1r2_not_low
      jl   check_r2
      cmp  ax,cx
      jg   r1r2_not_low
check_r2:
      cmp  bx,di
      jg   r1r2_not_low
      jl   jmp_go_both
      cmp  ax,si
      jg   r1r2_not_low
jmp_go_both:
      jmp  go_both
c_loop0y:
      jmp  c_loop0
r1r2_not_low:
      mov  ax,tao
      mov  bx,taoh
      cmp  dx,di
      jg   go_x_young_man
      jne  go_y
      cmp  cx,si
      jg   go_x_young_man
go_y:
; xsquar is best so increment y
      dec  y
      add  ax,t1   ;r1
      adc  bx,t1h
      mov  tao,ax
      mov  taoh,bx
      mov  ax,xsquar
      mov  bx,xsquarh
      add  t1,ax
      adc  t1h,bx
      cmp  y,0
      jg   c_loop0y
      jmp  done_circ
go_x_young_man:
; ysquar gives best result
; so we go in x direction
;
      inc  xp
      cmp  xp,7
      jle  low_xp
      inc  x
      mov  xp,0
low_xp:
      add  ax,t2   ;r2
      adc  bx,t2h
      mov  tao,ax
      mov  taoh,bx
      mov  ax,ysquar
      mov  bx,ysquarh
      add  t2,ax
      adc  t2h,bx
      jmp  c_loop0
go_both:
; here the corner dot it low
      mov  ax,tao
      mov  bx,taoh
      dec  y
      inc  xp
      cmp  xp,7
      jle  low_xp0
      inc  x
      mov  xp,0
low_xp0:
      add  ax,t1   ;r1
      adc  bx,t1h
      add  ax,t2   ;r2
      adc  bx,t2h
      mov  tao,ax
      mov  taoh,bx
      mov  ax,ysquar
      mov  bx,ysquarh
      add  t2,ax
      adc  t2h,bx
      mov  ax,xsquar
      mov  bx,xsquarh
      add  t1,ax
      adc  t1h,bx
      cmp  y,0
      jg   c_loop0x
      jmp  done_circ
c_loop0x:
      jmp  c_loop0
done_circ:
      call cs:[put_dot]
      mov   ax,0
      clc
      ret

dot_do:
; this routine puts a dot at virtual point x,y distance
; from sx,sy,spnt
; strategy is to xor a dot onto the screen
;
; set up the es:di for the first point fix
;
; this must be changed for the real version
; first get to the right row
;
; we do this routine 4 times, once for each dot
;
;
     call do_dot2
     neg  y
     call do_dot2
     neg  y
     ret
do_dot2:
     mov  ax,vid_len
     mul  interlace
     mov  bx,ax
       mov   ax,y      ; center of circle
       add   ax,sy
       sub   ax,erow    ; upper left hand corner of screen
       cmp   ax,0
       jg    on_x
off_x:
       ret
on_x:
       cmp   ax,bx
       jge   off_x
       mov   cline,ax
       mov   dx,0
       div   interlace
       mov   bx,ax
       mov   ax,dx
       mov   cx,2000h
       mul   cx
       mov   di,ax
       mov   ax,bx
       mul   vid_wid    ; get offset into picture
;  ax has start postion from start of buffer of point
;  dx has the interlace lines
       add   di,ax      ; start of offset into picture
;
; now find the x position
       push  di
       call  do_dot3
       pop   di
       neg   x
       neg   xp
       call  do_dot3
       neg   x
       neg  xp
       ret
do_dot3:
       mov   ax,sx
       add   ax,x     ; start x column
       sub   ax,ecol   ; upper left of screen
       mov   cx,spnt
       add   cx,xp
       cmp   cx,0
       jge   dd_4
       dec   ax
       add   cx,8
dd_4:
       cmp   cx,8
       jl    dd_5
       sub   cx,8
       inc   ax
dd_5:
       cmp   ax,0
       jl    off_x
       cmp   ax,vid_wid
       jge   off_x
       add   di,ax
       mov   vesx,ax
       cmp   mode,-1
       jne   no_vesa1
       call  calc_bank
       add   di,vesx
no_vesa1:
       mov   al,80h
       shr   al,cl
       xor   byte ptr es:[di],al
       ret
;
getcolor:
; this is used by both line 1, and line 2 and anybody else,
; bx is all set
       mov  si,colori
       shl  si,1
       shl  si,1
       shl  si,1
       shl  si,1  ; start of pattern
       mov  ax,y
       and  ax,7
       shl  ax,1
       add  si,ax
       mov  ax,vx
       shr  ax,1   ; get rid of points
       shr  ax,1
       shr  ax,1
       and  ax,1
       add  si,ax
       mov  al,colors[si]
       cmp  appl_sw,3
       jl   no_neg_c
       xor  al,0ffh
no_neg_c:
       and  al,color[bx]
       ret
;
punchit:
; this punches a hole for point
       cmp  appl_sw,0
       je   cont_punch
       cmp  appl_sw,3
       je   cont_punch
       mov  bx,vx
       and  bx,7
       ret
cont_punch:
       mov  bx,vx
       and  bx,7
       mov  al,punch[bx]
       and  byte ptr es:[di],al
       ret
;
do_point:
; do points for linew
      mov  ax,y
      push ax
      mov  ax,x
      push  ax
      mov   ax,xp
      push  ax
      mov   cx,linew
      inc   cx
      mov   bx,cx
      shr   bx,1
      sub   y,bx
wid_loop0:
      push  cx
      mov   ax,x
      push  ax
      mov   ax,xp
      push  ax
      mov   cx,linew
      inc   cx
      mov   bx,cx
      shr   bx,1
      sub   xp,bx
      cmp   xp,0
      jge   wid_loop1
      add   xp,8
      dec   x
wid_loop1:
      push  cx
;
call  do_point0
;
      pop   cx
      inc   xp
      cmp   xp,8
      jl    wl_2
      sub   xp,8
      inc   x
wl_2:
      loop  wid_loop1
      pop   ax
      mov   xp,ax
      pop   ax
      mov   x,ax
      inc   y
;
      pop   cx
      loop  wid_loop0
      pop   ax
      mov   xp,ax
      pop   ax
      mov   x,ax
      pop   ax
      mov   y,ax
      ret


do_point0:
; calculate es:di
; on entry, x,xp, and y have the relative point, sx,spnt and sy
; are the center.
;
        call  do_point1
     neg  y
        call  do_point1
     neg  y
     ret
        ret
do_point1:
; calculate y direction stuff first
;--get the es:di---------------
       mov   ax,8000h  ; segmentsize
       mov   dx,0
       div   vwid      ; virtual width
;    ax has the lines per segment
       mov  cx,ax
       mov   dx,0
       mov   ax,sy     ; y direction
       add   ax,y     ; starting y
       cmp   ax,0
       jge   do_p1
       ret
do_p1:
       cmp   ax,maxlines
       jl    do_p2
       ret
do_p2:
       div   cx
; ax has the number of the segments
; dx has the remainding lines
       mov   work_seg,ax
       call  get_curr_seg
       mov   es,ax
       mov   ax,dx
       mul   vwid
       mov   di,ax
; now the x stuff
       push  di
       call do_point2
       pop   di
       neg   x
       neg   xp
       call do_point2
       neg   x
       neg   xp
       ret
do_point2:
        mov   ax,sx
        add   ax,x
        mov   bx,spnt
        add   bx,xp
        cmp   bx,0
        jge   do_p3
        add   bx,8
        dec   ax
do_p3:
        cmp   bx,8
        jl   do_p4
        sub   bx,8
        inc   ax
do_p4:
       cmp   ax,0
       jge   do_p5
       cmp   bx,0
       jge   do_p5
       ret
do_p5:
       cmp   ax,vwid
       jl    do_p6
       ret
do_p6:
       add   di,ax
       mov   vx,bx  ; point info for color routines
       shl   ax,1
       shl   ax,1
       shl   ax,1
       add   vx,ax
;  es:di points to current place in picture
;-------------------------------
;
; do a point in es:di with the bits in vx,vy
; es:di points to the dot, vx has the point address
       call punchit
       call getcolor  ; gets a color in al and a jam in ah
       cmp  appl_sw,1
       je   xor_dot
       cmp  appl_sw,4
       je   xor_dot
; this ors it to screen, if appl_sw is 0 then it is punched
       or   byte ptr es:[di],al
       ret
xor_dot:
       xor   byte ptr es:[di],al
       ret
;-------------------------------
cseg  ends
      end
