print macro string
     call  present
     mov   curx,0
     mov   cury,0
     mov   left_margin,0
     lea   dx,string
     call  print_string
     endm
; OKFILE2 is the write routines
;
;
INCLUDE     f:\ok\okfiles.asm
buffersize  EQU   4000h
lzbuffer    equ   4000h
dseg     SEGMENT PUBLIC 'DATA'
     ASSUME CS:cseg,DS:dseg,ES:dseg
;
EXTRN     buffer:WORD,width_bytes:WORD,height_pix:WORD
extrn     pcb_headero:byte,msp_headero:byte,MAC_HEADERO:WORD
extrn     width_pix:word,spoint:word,lpoint:word
extrn     curx:word,cury:word,left_margin:word
extrn    srow:word,lrow:word,scol:word,lcol:word
extrn     vint:word,vphase:word,strg:byte,xor_raw:byte
extrn     planes:word,color_map:byte
extrn     cut_headero:word
extrn     sfl_headero:word
extrn     mak_headero:word
;
; local only stuff used by the programs
pass     DW    0
buffcount   DW    0
in_buffer   DW    0
nrd_string db  '000,000',13,10
;
sfl_mess   db  'Enter the letter that this image represents:',0,'$'
;
dseg     ENDS
cseg     SEGMENT PUBLIC 'CODE'
     ASSUME CS:cseg,DS:dseg,ES:dseg
EXTRN     reset_segs:NEAR,read_file:NEAR,print_string:near
extrn     blop:near,getkey:near,present:near
extrn     next_wait:near,fill_buffer:near,write_file:near
public     write_raw,msp_write,msp_out
public     pcb_out,mac_out,mac_write,mak_out
public    nrd_out,nrd_write
;
;
;  LOCAL Variables
;
;
;
end_switch   db  0  ; tells if we are in end_game
;
packbitsx:
public packbitsx
; si and di are set, cx has the length of line to unpack
     mov     bx,di   ; the string counter
     MOV     dx,0  ; the counter
; get first byte of line here to prime pump
     lodsb
     mov     ah,al
; this is the loop for the 73 bytes of the line
mac_loop2:
;
;
; this loop is to pass through the 72 bytes looking for a
; string to compress
;
     dec     cx
     cmp     cx,0   ;have we done 72?
     jle     end_mac_loop1
; get the byte  ah has the last byte
;
     LODSB
     cmp     dx,127
     jl     check_mac_rep
     jmp     no_mac_rep
; check to see if its a repeater
check_mac_rep:
     cmp     ah,al
     je     got_repeat
; here it is not a repeat, but do we have a repeat in the works?
     cmp     dx,0
     je     no_repeat
no_mac_rep:
; here we have a repeat in the works and must store it
     PUSH    AX
     mov     al,dl
     NEG     AL
     STOSB
     MOV     AL,ah
     xor     al,0ffh
     STOSB
     POP     AX
     MOV     dx,0
     MOV     ah,AL
     mov     bx,di
; we have finished out the repeat, now do the non_repeat
; the guy in ah is now a new guy, but er have to decide
; if he is the start of a new repeat or not
     jmp     mac_loop2
got_repeat:
; here we set up repeater stuff
; check to see if we are in an old string
; al=ah, so we are safe to assume we have a repeat
;
     inc     dx
     MOV     ah,al
     mov     bx,di
     jmp     mac_loop2
no_repeat:
; here there is a non repeat in al
; ah has the last repeater
     xchg    ah,al
; find out if we have to initialize the count guy
     cmp     bx,di  ; are we at the first guy?
     jne     by_zero
; the first byte of a string of no repeats is the count
     PUSH    AX
     mov     AL,-1
     STOSB
     POP     AX
by_zero:
     xor     al,0ffh
     STOSB
     inc     byte ptr es:[bx]
     jmp     mac_loop2  ; go back and get another
end_mac_loop1:
; check to see if there is anything in the works to wory about
     cmp     dx,0
     je     no_repeat1
; here we have a repeat in the works and must store it
     mov     al,dl
     NEG     AL
     STOSB
     MOV     AL,ah
     xor     al,0ffh
     STOSB
     mov     dx,0
     jmp     no_repeat2
no_repeat1:
; there must be a string in ah
     cmp     bx,di  ; are we at the first guy?
     jne     by_zero2
; the first byte of a string of no repeats is the count
     mov     AL,-1
     STOSB
by_zero2:
     mov     al,ah
     xor     al,0ffh
     STOSB
     inc     byte ptr es:[bx]
no_repeat2:
; returns with si and di set and a line compressed from si to di
     ret
nrd_out:
   public nrd_out
     call  reset_segs
     call  calc_file_size
; write the nrd icon header
     MOV     AX,WIDTH_BYTES  ;SAVE AS BYTES
     SHL     AX,1     ;MAKE INTO BYTES
     SHL     AX,1     ;
     SHL     AX,1     ;
     cmp     ax,160
     jle     nrd_o1
     mov     ax,160
nrd_o1:
     mov     dx,ax
     mov     width_pix,ax
     add     ax,7
     shr     ax,1
     shr     ax,1
     shr     ax,1
     mov     width_bytes,ax
     mov     ax,dx
     mov     dx,0
     mov     cx,1000  ; up to 999
     div     cx
     mov     ax,dx
     mov     dx,0
     mov     cx,100
     div     cx
     or      al,30h
     mov     nrd_string,al
     mov     ax,dx
     mov     cl,10
     div     cl
     or      ax,3030h
     mov     word ptr nrd_string+1,ax
;
     MOV     AX,HEIGHT_PIX   ;SAVE AS PIXELS
     cmp     ax,100
     jle     nrd_o2
     mov     ax,100
nrd_o2:
     mov     height_pix,ax
     mov     dx,0
     mov     cx,1000  ; up to 999
     div     cx
     mov     ax,dx
     mov     dx,0
     mov     cx,100
     div     cx
     or      al,30h
     mov     nrd_string+4,al
     mov     ax,dx
     mov     cl,10
     div     cl
     or      ax,3030h
     mov     word ptr nrd_string+5,ax
;
     mov   cx,9
     lea   dx,nrd_string
     call  write_file
     call  reset_segs
     clc
     ret
nrd_write:
public nrd_write
; this writes out the strings of 0's and 1's
     call  reset_segs
; prime the pump by reading in a chunk of data
     call   fill_buffer
     jc     nrd_done0
     cmp    cx,0
     jle    nrd_done0
     mov    si,0
     jmp    cont_nrd
nrd_done0:
     stc
     ret
nrd_done:
     clc
     ret
cont_nrd:
     call   reset_segs
     mov    bp,width_bytes
     mov    ax,buffer
     mov    di,buffersize
     mov    si,0
     mov    cx,height_pix
     mov    es,ax
     mov    ds,ax
; this is the loop
nrd_loop0:
     push   cx
     mov    cx,bp
nrd_loop1:
     push   cx
     cld
     lodsb
     mov    cx,8
nrd_loop2:
     mov    dl,30h
     rcl    al,1
     jnc    nrd_1
     or     dl,1
nrd_1:
     mov    byte ptr es:[di],dl
     inc    di
     loop   nrd_loop2
     pop    cx
     loop   nrd_loop1
     pop    cx
     mov    al,13
     stosb
     mov    al,10
     stosb
     loop   nrd_loop0
     mov    al,26
     stosb
     mov   cx,di
     sub   cx,buffersize
     mov   dx,buffersize
     cmp   cx,0
     jle   by_nrd_write
     call  write_file
by_nrd_write:
     call  reset_segs
     stc
     ret

     PUBLIC  CUT_OUT
CUT_OUT:
     call    reset_segs
     call  calc_file_size
     MOV     AX,WIDTH_BYTES  ;SAVE AS BYTES
     SHL     AX,1     ;MAKE INTO BYTES
     SHL     AX,1     ;
     SHL     AX,1     ;
     MOV     CUT_HEADERo.CUT_WIDTH,AX
     MOV     AX,HEIGHT_PIX   ;SAVE AS PIXELS
     MOV     CUT_HEADERo.CUT_HEIGHT,AX
;
;
     mov   cx,word ptr cut_headero
     lea   dx,word ptr cut_headero+2
     call  write_file
     ret



     PUBLIC  CUT_write
CUT_WRITE:
     call  reset_segs
; prime the pump by reading in a chunk of data
     mov    ax,buffer
     mov    es,ax
     mov    ds,ax
     call   fill_buffer
     jc     cut_done0
     cmp    cx,0
     jle    cut_done0
     mov    si,0
     jmp    cont_cut
cut_done0:
     stc
     ret
cut_done:
     cmp    di,buffersize+2
     jle    leave_cut
     call   cut_outfile
leave_cut:
     stc
     ret
cont_cut:
     push   cx  ; save the cx from the fill buffer
;
; have a buffer full of data at si
; have a count of width in BP
; have target at di
; have buffer count in CX
;
;  cut files are set up in blocks of information
; the first word of a block is the length of the block
; blocks are less than 4000h, lets limt them to the width in BP
;
;  the data is strings of bits.
;
;  if a byte has the 80h bit as zero it is a count of 1's and 0's
; which folow as bytes of 1's and zeros
; if the 80 bit is on then and it with 7f ans get a string
; of data 1's or zero's depending on the next byte
;
; we will modify this so that only even bytes are considered
; a byte of zeros or F's will result in in 80h string.
; non zero guys will result in counts of 1 and zero
;
; cx has returned from fill buffer with the count in es:[0]
;
     call   reset_segs
     mov  bp,width_bytes
     mov    ax,buffer
     mov    es,ax
     mov    ds,ax
     mov    di,buffersize+2 ; start of data
     mov    word ptr es:[buffersize],0
     mov    cx,bp
     inc    cx
cut_top:
     loop   cut_first0
     jmp    cut_filler
cut_first0:
     cld
     lodsb
cut_first:
     push   cx
; just got the first byte. Have to determine if there is a string
     mov    ah,0
     mov    dh,0  ; count of bits in this run
     mov    dl,0  ; bit we are working on
     mov    bx,di ; where the count is going
     mov    byte ptr es:[bx],0
     inc    di    ; where the data goes
     inc    word ptr es:[buffersize]
cut_loop:
;    start by finding if we are in a run
     cmp    al,0
     je     zero_run
     cmp    al,0ffh
     je     one_run
; non run situation
odd_cut:
     mov    cx,8
     mov    ah,al
cut_bit_loop:
     mov    al,0
     clc
     rcl    ah,1
     jnc    store_bit
     mov    al,1
store_bit:
     stosb
     inc    word ptr es:[buffersize]
     loop   cut_bit_loop
; check and see if it is flush buffer time
     add    byte ptr es:[bx],8
     cmp    byte ptr es:[bx],120
     jl     check_cut_buf
     pop    cx
     jmp    cut_top
check_cut_buf:
     pop    cx
     loop   cut_next
     jmp    cut_filler
cut_next:
     lodsb
     push   cx
     cmp    al,0
     je     end_odd_run
     cmp    al,0ffh
     je     end_odd_run
     jmp    odd_cut
end_odd_run:
     pop    cx
     jmp    cut_first
zero_run:
; here we have a zero run
     mov    dl,0
     mov    al,0
     jmp    cut_run
one_run:
     mov    dl,0ffh
     mov    al,1
cut_run:
     stosb
     inc    word ptr es:[buffersize]
cut_run1:
     add    byte ptr es:[bx],8
     cmp    byte ptr es:[bx],120
     jl     more_run
     or     byte ptr es:[bx],80h
     pop    cx
     jmp    cut_top
more_run:
     pop    cx
     loop   cut_first1
     or     byte ptr es:[bx],80h
     jmp    cut_filler
cut_first1:
     lodsb
     push   cx
     cmp    al,dl
     je     cut_run1
     pop    cx
     or     byte ptr es:[bx],80h
     jmp    cut_first
;
cut_done2:
     jmp   cut_done
;
cut_filler:
; the line is finished
;    reached here because we ran out of bp (in cx)
     call  cut_outfile
     pop   cx
     sub   cx,bp
     cmp   cx,0
     jle   next_cut_fill
     jmp   cont_cut
next_cut_fill:
     call  cut_fill
     jc    done_cut3
     cmp   cx,0
     je    done_cut3
     mov   si,0
     jmp   cont_cut
done_cut3:
     stc
     ret
;
;
;
;
;
;
;
;
cut_fill:
     push   ax
     push   bx
     push   dx
     push   di
     push   ds
     push   es
     call   reset_segs
     call   next_wait
     call   reset_segs
     call   fill_buffer
     pop    es
     pop    ds
     pop    di
     pop    dx
     pop    bx
     pop    ax
     ret
cut_outfile:
     push   ax
     push   bx
     push   cx
     push   dx
     push   si
     push   bp
     push   ds
     push   es
     mov    al,0
     stosb
     call   reset_segs
     mov    dx,buffersize
     mov    cx,di
     sub    cx,buffersize
     mov    ds,buffer
     inc   word ptr ds:[buffersize]
     call   write_file
     pop    es
     pop    ds
     pop    bp
     pop    si
     pop    dx
     pop    cx
     pop    bx
     pop    ax
     ret

;
PCB_out:
     call  reset_segs
     call  calc_file_size
     MOV   ax,WIDTH_bytes
     mov   PCB_HEADERo.PCB_width_bytes,ax
     shl   ax,1
     shl   ax,1
     shl   ax,1
     dec   ax
     mov   pcb_headero.pcb_lr_x,ax
     mov   dx,0
     MOV   ax,HEIGHT_PIX
     div   planes
     dec   ax
     mov   PCB_HEADERO.PCB_LR_y,ax
     mov   ax,planes
     mov   PCB_HEADERO.PCB_num_planes,al
; set up colors
     lea   si,color_map
     lea   di,PCB_HEADERO.PCB_COLORS
     mov   cx,16
     cld
pcol0:
     lodsb
; test for reds, green blue - 4,2,1 and 32,16,8
     mov   bl,0
     test  al,4
     jz    no_red
     mov   bl,55h
     test  al,32
     jz    no_red
     mov   bl,0aah
     push  ax
     and   al,56
     cmp   al,56
     pop   ax
     jne   no_red
     mov   bl,0ffh
no_red:
     mov   al,bl
     stosb
;
     mov   bl,0
     test  al,2
     jz    no_green
     mov   bl,55h
     test  al,16
     jz    no_green
     mov   bl,0aah
     push  ax
     and   al,56
     cmp   al,56
     pop   ax
     jne   no_green
     mov   bl,0ffh
no_green:
     mov   al,bl
     stosb
;
     mov   bl,0
     test  al,1
     jz    no_blue
     mov   bl,55h
     test  al,8
     jz    no_blue
     mov   bl,0aah
     push  ax
     and   al,56
     cmp   al,56
     pop   ax
     jne   no_blue
     mov   bl,0ffh
no_blue:
     mov   al,bl
     stosb
     loop  pcol0
;
;
;
;
;
;
     mov   cx,word ptr pcb_headero
     lea   dx,word ptr pcb_headero+2
     call  write_file
     ret

pcb_write:
public pcb_write
; write out the data
;
;
     call   reset_segs
     mov    ax,buffer
     mov    di,buffersize
     mov    bp,width_bytes
     mov    es,ax
     mov    ds,ax
pcb_loop:
     push   bp
     push   di
     push   ds
     push   es
     call   next_wait
     call   fill_buffer
     pop    es
     pop    ds
     pop    di
     pop    bp
     jc     pcb_done
     cmp    cx,0
     jle    pcb_done
     mov    si,0
     jmp    cont_pcb
pcb_done:
     stc
     ret
cont_pcb:
; set upt the compression loop
pcb_loop0:
     lodsb    ; prime the pump
     mov   ah,al
     mov   dx,0   ; counter
     mov   bx,bp  ; bytes in a line
     dec   bx
     cmp   bx,0
     jle   done_pcb_line
pcb_loop1:
     dec   bx
     cmp   bx,0
     jl    done_pcb_line
     lodsb
     xchg  ah,al
     cmp   ah,al
     je    got_pcb_repeat
; do we have a repeat in the works
     cmp   dx,0
     jne   store_count
     push  ax
     mov   ah,0
     cmp   ax,63
     pop   ax
     jg    store_count
     jmp   store_pcb
got_pcb_repeat:
     cmp   dx,62
     jge   store_count
     inc   dx
     jmp   pcb_loop1
store_count:
     inc  dx
     or   dx,0c0h
     push ax
     mov  al,dl
     stosb
     pop  ax
     mov  dx,0
store_pcb:
     stosb
check_di:
     cmp   di,7effh
     jl    pcb_loop1
     push  ax
     push  bx
     push  cx
     push  dx
     push  bp
     mov   cx,di
     sub   cx,buffersize
     mov   dx,buffersize
     cmp   cx,0
     jle   by_pcb_write
     call  write_file
by_pcb_write:
     mov   di,buffersize
     pop   bp
     pop   dx
     pop   cx
     pop   bx
     pop   ax
     jmp   pcb_loop1
done_pcb_line:
 ; have run out of bytes in line
; ah has not been handled
     mov   al,ah
     cmp   dx,0
     jg    repeat_pcb2
     mov   ah,0
     cmp   ax,63
     jle   store_pcb2
repeat_pcb2:
     inc  dx
     or   dl,0c0h
     push ax
     mov  al,dl
     stosb
     pop  ax
store_pcb2:
     stosb
; check end of buffer
     sub   cx,bp
     cmp   cx,0
     jle   get_new_pcb_buff
     jmp   pcb_loop0
get_new_pcb_buff:
     push  ax
     push  bx
     push  cx
     push  dx
     push  bp
     mov   cx,di
     sub   cx,buffersize
     mov   dx,buffersize
     cmp   cx,0
     jle   by_write_pcb2
     call  write_file
by_write_pcb2:
     mov   di,buffersize
     pop   bp
     pop   dx
     pop   cx
     pop   bx
     pop   ax
     jmp   pcb_loop

calc_file_size:
public calc_file_size
     mov     ax,lcol
     sub     ax,scol
     cmp     ax,0
     jg     got_f_width
     neg     ax
     push    ax
     push     bx
     mov     ax,lcol
     mov     bx,scol
     mov     scol,ax
     mov     lcol,bx
     mov     ax,spoint
     mov     bx,lpoint
     mov     spoint,bx
     mov     lpoint,ax
     pop     bx
     pop     ax
got_f_width:
     cmp     lpoint,0
     je     lpoint0
     inc     ax
lpoint0:
     MOV     WIDTH_bytes,ax
     shl     ax,1
     shl     ax,1
     shl     ax,1
     MOV     WIDTH_pix,ax
;
     mov  ax,lrow
     sub  ax,srow
     cmp  ax,0
     jg   got_f_height
     neg   ax
     push  ax
     push  bx
     mov     ax,lrow
     mov     bx,srow
     mov     srow,ax
     mov     lrow,bx
     pop     bx
     pop     ax
got_f_height:
;     mul     planes
     MOV     HEIGHT_PIX,ax
     ret

;
; Microsoft Paint is the model raw file
;
MSP_OUT:
     call   reset_segs
; have to calculate the hieght and height
     call    calc_file_size
     mov     ax,width_pix
     MOV     MSP_HEADERo.MSP_WIDTH,AX
     MOV     MSP_HEADERo.MSP_WIDTH1,AX
;
     mov  ax,height_pix
     MOV     MSP_HEADERo.MSP_HEIGHT,AX
     MOV     MSP_HEADERo.MSP_HEIGHT1,AX
     mov  cx,word ptr msp_headero
     lea  dx,word ptr msp_headero+2
     call write_file
     RET


MSP_write:
     call   reset_segs
     mov    vint,0

     CALL    write_RAW
     mov  cx,0
     mov  ax,0
     stc
     ret



; SFL is the soft font letter
;
;
SFL_OUT:
     call   reset_segs
; have to calculate the hieght and height
     call    calc_file_size
     mov     ax,width_bytes
     shl   ax,1
     shl   ax,1
     shl   ax,1
     mov   bx,ax
     xchg  al,ah
     MOV     SFL_HEADERo.SFL_WIDTH,AX
     shl   bx,1
     shl   bx,1
     xchg  bl,bh
     MOV     SFL_HEADERo.SFL_deltax,bx
;
     mov  ax,height_pix
     xchg  al,ah
     MOV     SFL_HEADERo.SFL_HEIGHT,AX
     MOV     SFL_HEADERo.SFL_TOP,AX
     mov   ax,width_bytes
     mul   height_pix
     add   ax,16
     mov   cx,100
     mov   dx,0
     div   cx
     mov   cl,10
     div   cl
     or    ax,3030h
     MOV   word ptr SFL_HEADERo.SFL_length,ax
     mov   ax,dx
     div   cl
     or    ax,3030h
     MOV   word ptr SFL_HEADERo.SFL_length+2,ax
; get the letter from the user
     print  sfl_mess
     call   getkey
     cmp   al,27
     je    sfl_err
     mov   ah,0
     mov   cx,100
     mov   dx,0
     div   cx
     or    al,30h
     MOV     SFL_HEADERo.SFL_ascii,al
     mov   ax,dx
     mov   cl,10
     div   cl
     or    ax,3030h
     MOV   word ptr SFL_HEADERo.SFL_ascii+1,ax
     mov  cx,word ptr sfl_headero
     lea  dx,word ptr sfl_headero+2
     call write_file
     jc    sfl_err
     call  present
     RET
sfl_err:
     call  present
     stc
     ret


SFL_write:
  public SFL_WRITE,SFL_OUT
     call   reset_segs
     mov    vint,0

     CALL    write_RAW
     mov  cx,0
     mov  ax,0
     stc
     ret



write_RAW:
; read raw will loop through reading and flush buffering until the
; buffer won't take it any more or the length is run out
     call  reset_segs
     mov   dx,0
     mov   ax,height_pix
     mul   width_bytes
wraw_loop:
     cmp   dx,0
     jne   no_dx
     cmp   ax,0
     jne   no_dx
     stc
     ret
no_dx:
     push  ds
     push  es
     push  ax
     push  dx
;
     push  ds
     call  fill_buffer
     pop   ds
; ax returns with some stuff in it, the 0 end of the buffer has it?
     jnc   got_some_stuff
     jmp   fake_fill
got_some_stuff:
; have to subtract out the ax to see if there is anything worth
; writing out
     pop   dx
     pop   ax
     clc
     sub   ax,cx
     jnc   ok_write1
     clc
     sub   dx,1
     jnc   ok_write1
     mov   dx,0
     add   ax,cx
     mov   cx,ax
     mov   ax,0
ok_write1:
; write the file
     call  xor_check
     push  ax
     push  dx
     mov  ax,buffer
     mov  es,ax
     mov  ds,ax
     mov  dx,0
     call write_file
     jc   exit_raw1
     call  next_wait
;
     pop    dx
     pop    ax
     pop    es
     pop    ds
     jmp    wraw_loop
exit_raw1:
     pop    dx
     pop    ax
     pop    es
     pop    ds
     stc
     ret
xor_check:
   public   xor_check
; check to see if we xor it
     push  ax
     push  cx
     push  si
     push  di
     push  ds
     push  es
     call  reset_segs
     cmp   xor_raw,0
     je    no_xor_raw
;
     mov  ax,buffer
     mov  es,ax
     mov  ds,ax
     mov   si,0
     mov   di,0
;
     cld
xor_raw_l:
     lodsb
     xor   al,0ffh
     stosb
     loop  xor_raw_l
no_xor_raw:
     pop   es
     pop   ds
     pop   di
     pop   si
     pop   cx
     pop   ax
     ret
fake_fill:
     call  reset_segs
     mov  ax,buffer
     mov  es,ax
     mov  ds,ax
     mov    di,0
     mov    al,0
     mov    cx,4000h
rep  stosb
     pop    dx
     pop    ax
     pop    es
     pop    ds
; still have alot of stuff to do
; now we have to go through the loop writing until it ends
wraw_write:
     cmp   dx,0
     jne   no_dx2
     cmp   ax,0
     jne   no_dx2
     stc
     ret
no_dx2:
     mov   cx,4000h
     clc
     sub   ax,4000h
     jnc   ok_write2
     clc
     sub   dx,1
     jnc   ok_write2
     add   ax,4000h
     mov   dx,0
     mov   cx,ax
     mov   ax,0
ok_write2:
     cmp   cx,0
     je    exit_raw
     call  xor_check
     push  ds
     push  es
     push  ax
     push  dx
     mov  ax,buffer
     mov  es,ax
     mov  ds,ax
     mov  dx,0
     call  next_wait
     call write_file
     pop    dx
     pop    ax
     pop    es
     pop    ds
     jc   exit_raw
;
     jmp    wraw_write
exit_raw:
     stc
     ret


mak_out:
     call    reset_segs
     mov     cs:end_switch,0
     mov     width_bytes,72
     mov     height_pix,720
     MOV     CX,512
     MOV     DX,OFFSET MAK_HEADERO
     call    write_file
     ret
mac_out:
; this sets up the stuff for compress
     call    reset_segs
     mov     cs:end_switch,0
     mov     width_bytes,72
     mov     height_pix,720
     MOV     AX,DI
     ADD     AX,640
     SUB     AX,128
     XCHG    AH,AL
     MOV     WORD PTR MAC_HEADERO.MAC_FORK+2,AX
; write file name to mac_file_name
     lea     si,strg
     lea     di,mac_headero.mac_file_name
     mov     cx,32
     cld
rep     movsb
;     WRITE MAC HEADER
     MOV     CX,640
     MOV     DX,OFFSET MAC_HEADERO.MAC_VERSION
     call    write_file
     ret

mac_write:
; this writes out the mac file and is called from compress
public  mac_write
; enter here, set up stuff for first and subsequent passes
     call    reset_segs
     MOV     DX,height_pix     ;COUNT of lines
     mov     ax,buffer
     mov     es,ax
     mov     ds,ax
;
mac_loop:
     push    dx
; top of loop. keep coming here until dx is zero
     cmp     cs:end_switch,0
     jne     mac_fake_fill
     push    ds
     push    es
     call    fill_buffer
     pop     es
     pop     ds
     cmp     cx,0
     jne     good_fill
; ran out of stuff
; time to go back. have to rely on physical eof
;
     jmp     end_game
mac_fake_fill:
; clean out the buffer
     mov   di,0
     mov   ax,0
     mov   cx,buffersize/2
rep  stosw
     mov     ax,dx
     cmp     ax,100
     jle     good_fill1
     mov     ax,100
     jmp     good_fill1
good_fill:
; the cx register has the amount of stuff in the buffer
; cx will always be a multiple of lines so calculate the number of
; lines
     push    ds
     mov     ax,dseg
     mov     ds,ax
     mov     ax,cx
     mov     cx,width_bytes
     mov     dx,0
     add     ax,width_bytes
     pop     ds
     dec     ax
     div     cx
good_fill1:
; ax has the number of lines we do this pass
     mov     cx,ax
     mov     si,0
     mov     di,buffersize
     push    cx  ; save current count for later
mac_loop1:
; loop here untill the thing is done
;
;
;
;
; this is the start of looping through the lines
;
;
;
     push    cx
; check to see if we need to write the buffer
;
     cmp     di,7f00h
     jl     no_write
     mov     cx,di
     mov     dx,buffersize
     sub     cx,buffersize
     call    next_wait
     call    write_file
     mov     di,buffersize
no_write:
     MOV     CX,72   ; count of bytes on line
     call  packbitsx   ; xor version of packbits
     pop     cx
     loop    mac_loop1
; here we have finished the buffer
; have to write the buffer
     cmp     di,0
     jle     no_flush
     mov     cx,di
     mov     dx,buffersize
     sub     cx,buffersize
     call    write_file
     call    next_wait
     mov     di,buffersize
no_flush:
;
;    now check to see if there is more to do
;
     pop     cx   ; lines this time
     pop     dx   ; total lines
     sub     dx,cx
     cmp     dx,0
     jle     done_game
     jmp     mac_loop
done_game:
     mov     cx,0
     stc
     ret
end_game:
; the end_game fills up to the remaining 720 lines
     mov     di,0
     mov     cx,buffersize
     cld
     mov   al,0
rep  stosb
     mov    cs:end_switch,1
     mov    di,buffersize
     jmp    mac_fake_fill


pwidth_bytes  dw  0
pac_write:
; just like pac_write, but requires no fakes
   public pac_write
     call    reset_segs
     mov     ax,width_bytes
     mov     cs:pwidth_bytes,ax
     MOV     DX,height_pix     ;COUNT of lines
     mov     ax,buffer
     mov     es,ax
     mov     ds,ax
pac_loop:
     push    dx
; top of loop. keep coming here until dx is zero
     push    ds
     push    es
     call    fill_buffer
     pop     es
     pop     ds
     cmp     cx,0
     jne     good_pfill
; ran out of stuff
; time to go back. have to rely on physical eof
;
     jmp     pend_game
good_pfill:
; the cx register has the amount of stuff in the buffer
; cx will always be a multiple of lines so calculate the number of
; lines
     push    ds
     push    es
     call    reset_segs
     pop     es
     mov     ax,cx
     mov     cx,width_bytes
     mov     dx,0
     add     ax,width_bytes
     pop     ds
     dec     ax
     div     cx
good_pfill1:
; ax has the number of lines we do this pass
     mov     cx,ax
     mov     si,0
     mov     di,buffersize
     push    cx  ; save current count for later
pac_loop1:
; loop here untill the thing is done
;
; this is the start of looping through the lines
;
     push    cx
; check to see if we need to write the buffer
;
     cmp     di,7f00h
     jl     no_pwrite
     mov     cx,di
     mov     dx,buffersize
     sub     cx,buffersize
     call    next_wait
     call    write_file
     mov     di,buffersize
no_pwrite:
      MOV     CX,cs:pwidth_bytes  ; count of bytes on line
;
     call  packbits
;
     pop     cx
     loop    pac_loop1
; here we have finished the buffer
; have to write the buffer
     cmp     di,0
     jle     no_pflush
     mov     cx,di
     mov     dx,buffersize
     sub     cx,buffersize
     call    write_file
     call    next_wait
     mov     di,buffersize
no_pflush:
;
;    now check to see if there is more to do
;
     pop     cx   ; lines this time
     pop     dx   ; total lines
     sub     dx,cx
     cmp     dx,0
     jle     pdone_game
     jmp     pac_loop
pdone_game:
pend_game:
     mov     cx,0
     stc
     ret

;
packbits:
public packbits
; si and di are set, cx has the length of line to unpack
     mov     bx,di   ; the string counter
     MOV     dx,0  ; the counter
; get first byte of line here to prime pump
     lodsb
     mov     ah,al
; this is the loop for the 73 bytes of the line
pac_loop2:
;
;
; this loop is to pass through the 72 bytes looking for a
; string to compress
;
     dec     cx
     cmp     cx,0   ;have we done 72?
     jle     end_pac_loop1
; get the byte  ah has the last byte
;
     LODSB
     cmp   dx,127
     jl    check_pac_rep
     jmp  no_pac_rep
; check to see if its a repeater
check_pac_rep:
     cmp     ah,al
     je     xgot_repeat
; here it is not a repeat, but do we have a repeat in the works?
     cmp     dx,0
     je     xno_repeat
; here we have a repeat in the works and must store it
no_pac_rep:
     PUSH    AX
     mov     al,dl
     NEG     AL
     STOSB
     MOV     AL,ah
     STOSB
     POP     AX
     MOV     dx,0
     MOV     ah,AL
     mov     bx,di
; we have finished out the repeat, now do the non_repeat
; the guy in ah is now a new guy, but er have to decide
; if he is the start of a new repeat or not
     jmp     pac_loop2
xgot_repeat:
; here we set up repeater stuff
; check to see if we are in an old string
; al=ah, so we are safe to assume we have a repeat
;
     inc     dx
     MOV     ah,al
     mov     bx,di
     jmp     pac_loop2
xno_repeat:
; here there is a non repeat in al
; ah has the last repeater
     xchg    ah,al
; find out if we have to initialize the count guy
     cmp     bx,di  ; are we at the first guy?
     jne     xby_zero
; the first byte of a string of no repeats is the count
     PUSH    AX
     mov     AL,-1
     STOSB
     POP     AX
xby_zero:
     STOSB
     inc     byte ptr es:[bx]
     jmp     pac_loop2  ; go back and get another
end_pac_loop1:
; check to see if there is anything in the works to wory about
     cmp     dx,0
     je     xno_repeat1
; here we have a repeat in the works and must store it
     mov     al,dl
     NEG     AL
     STOSB
     MOV     AL,ah
     STOSB
     mov     dx,0
     jmp     xno_repeat2
xno_repeat1:
; there must be a string in ah
     cmp     bx,di  ; are we at the first guy?
     jne     xby_zero2
; the first byte of a string of no repeats is the count
     mov     AL,-1
     STOSB
xby_zero2:
     mov     al,ah
     STOSB
     inc     byte ptr es:[bx]
xno_repeat2:
; returns with si and di set and a line compressed from si to di
     ret

cseg     ENDS
     END
;
