FILE_HEADER    STRUC
FTYPE    DB    ?,?,?    ;FILE TYPE
INPUT    DW    ?    ;HEADER READ ROUTINE
OUTPUT    DW    ?    ;HEADER WRITE ROUTINE
HEADER    DW    ?    ;LOCATION OF FILE HEADER
HEADERo    DW    ?    ;LOCATION OF FILE HEADER
DISK_IN    DW    ?    ;HOW TO READ FILE DATA
DISK_OUT    DW    ?    ;HOW TO WRITE FILE DATA
DISK_COUNT dw    ?    ; count of header_length
FILE_HEADER    ENDS
; Norand icons
NRD_count equ 0
NRD struc
    dw NRD_count
NRD ends
;
; TRS-80 model 4 Hi Res files
;
TRS_count equ 0
TRS    struc
     dw TRS_count
TRS    ends
;
; Complete fax files

CFX_count equ 100
CFX    struc
     dw CFX_count
CFX_ID   db  80h,01,40h
CFX_TYPE db  02
         db  6 dup(0) ; time
         db  8 dup(0) ; date
         db 60 dup(0) ; reserved
CFX_RES  db  2 ; resolution 0 = 100*200, 2 is 200*200
         db  0 ; starting pixel column
         db 10 dup(0) ; reserved
CFX_HRES db  0 ; 1=100,2=100,3=300,4=400,15=150,75=75
CFX_WID  dw  1728 ; type 1+2, type 3 has a value here
         db  7 dup(0) ; reserve
CFX    ends
;
;
;
; Matrix PCT files

PCT_count equ 6
PCT    struc
     dw PCT_count
         db  0
PCT_LEN  dw  0
PCT_WID  dw  0
         db  1
PCT    ends
;
;
; Dr. Halo PIC files
;
HAL_count equ 10
HAL    struc
     dw HAL_count
HAL_sig  db  'AH'
HAL_ver  dw  0
         db  0
         db  2
HAL_id   db  0
         dw  0
HAL    ends
;
;
;  GEM DRAW Metafile
;
GDW_count equ 82
GDW    struc
    dw   GDW_count
    dw  0ffffh
    dw  0eh
    dw  65h
    dw  2h
gdw_minx dw 0
gdw_miny dw 0
gdw_maxx dw 0
gdw_maxy dw 0
    dw  0771h
    dw  0771h
    dw  0
    dw  7fffh
    dw  7fffh
    dw  0
    dw 0fh
    dw 0
    dw 1
    dw 0
    dw 1
    dw 10h
    dw 1h
    dw 0
    dw 0
    dw 1
    dw 0
    dw 6ch
    dw 0
    dw 2
    dw 0
    dw 0
    dw 0
    dw 11h
    dw 0
    dw 1
    dw  0
    dw  1
    dw 20h
    dw 0
    dw 1
    dw 0
    dw 1
GDW    ends
;
;
;  Computer Graphic Meta Files
;
CGM_count equ 256
CGM    struc
    dw   CGM_count
CGM_begin db 20h,2eh,0ch,'METAFILE.DAT',0
cgm_vers db  10h,22h,0,1   ; version 1
cgm_vdmlist db 11h,3fh,00h,0c0h
    db   00h,01h,00h,01h,00h,01h,00h,03h
db  00h,01h,00h,04h,00h,01h,00h,06h,00h,01h,00h,07h,00h,01h,00h,08h
db  00h,01h,00h,09h,00h,01h,00h,0Dh,00h,02h,00h,00h,00h,02h,00h,01h
db  00h,02h,00h,02h,00h,02h,00h,03h,00h,02h,00h,04h,00h,02h,00h,05h
db  00h,02h,00h,0Bh,00h,03h,00h,01h,00h,03h,00h,02h,00h,03h,00h,03h
db  00h,03h,00h,04h,00h,03h,00h,05h,00h,04h,00h,01h,00h,04h,00h,02h
db  00h,04h,00h,03h,00h,04h,00h,04h,00h,04h,00h,05h,00h,04h,00h,06h
db  00h,04h,00h,07h,00h,04h,00h,08h,00h,05h,00h,02h,00h,05h,00h,03h
db  00h,05h,00h,04h,00h,05h,00h,06h,00h,05h,00h,07h,00h,05h,00h,08h
db  00h,05h,00h,0Ah,00h,05h,00h,0Eh,00h,05h,00h,0Fh,00h,05h,00h,10h
db  00h,05h,00h,12h,00h,05h,00h,15h,00h,05h,00h,16h,00h,05h,00h,17h
db  00h,05h,00h,18h,00h,05h,00h,1Ah,00h,05h,00h,20h,00h,06h,00h,01h
db  00h,07h,00h,01h,00h,07h,00h,02h
;
cgm_vdctype   db   10h,62h,00h,01h
cgm_maxcol    db   11h,0a2h,00,0ffh
cgm_ipres    db   10h,82h,00,10h
cgm_idxp    db   10h,0c2h,00,10h
cgm_colp    db   10h,0e2h,00,10h
cgm_colip    db   11h,02h,00h,10h
cgm_beginp    db   20h,6eh,00h,00,00,00,00,'Picture 1'
; up to here 256
cgm_body    db   20h,80h
cgm_coltab    db   53h,5fh,6,2
    db 0,0,0,0,0,0,0,0
CGM    ends
;
;
;  Printer Magic Graphics
;
PMG_count equ 24
PMG    struc
    dw   PMG_count
PMG_SIG db 'PMGRAF'
    dw 0,0
pmg_width   dw 0
    dw 0
pmg_length  dw  0
pmg    ends
;
;
;  Print Power .001 files
;
pow_count equ 2
pow    struc
    dw   pow_count
pow_num dw 14h
pow    ends
;
;
;  WPG Word Perfect Graphic files
;
wpg_count equ 16
wpg    struc
    dw   wpg_count
wpg_sig    db  -1,"WPC"
wpg_start  dd   16
wpg_info   db   1,16h,1,0
wpg_key    dw   0
    dw   0
    db  0
wpg    ends
;
;
;  SHP, Newsmaster SHP
;
shp_count equ 0
shp    struc
    dw   shp_count
    db  0bh
shp_height  db  0
shp_width   db  0
    db  0
shp    ends
;
;
;  DAT, print shop graphics
;
dat_count equ 0
dat    struc
    dw   dat_count
dat    ends
;
;
;  COM, self displaying com files
;
com_count equ 1627h
com    struc
    dw   com_count
com    ends
;
;
;  SYS, self displaying sys files
;
sys_count equ 1c50h
sys    struc
    dw   sys_count
sys    ends
;
;
;  FAX, fax files
;
FAX_count equ 0
FAX    struc
    dw  fax_count
FAX    ends
;
;
;
;  SLD is autocad slide file type   s
;
SLD_count equ 31
SLD    struc
    dw  sld_count
SLD_sig  db  'AutoCAD Slide',13,10,26,0
SLD_type db 86
SLD_level db 2
SLD_wid  dw 0
SLD_len  dw 0
SLD_aspect dd 1
    dw 0
sld_test   dw 1234h
sld_fill   dw 0
SLD    ends
;
;
;  DXF is autocad interchange file
;
DXF_count equ 25
DXF    struc
    dw  DXF_count
DXF_sig    db  "0",13,10,"SECTION",13,10,"2",13,10,"ENTITIES",13,10
DXF    ends
;
;
;  DXB is autocad binary files
;
DXB_count equ 19
DXB    struc
    dw  DXB_count
DXB_sig  db  'AutoCAD DXB 1.0',13,10,26,0
DXB    ends
;
;
;
;
;
;  PDA is the palantir graphics files
;
PDA_count equ 26
PDA    struc
    dw  pda_count
PDA_TYPE db  '0'    ; 0 is unpacked?
    db  '00000'
    db  '00000'
pda_width db '00000'
pda_height db '00000'
    db '0'
    db '0'
pda_res    db '4'
    db '0'
    db 0ah   ; ^j
PDA    ends
;
;
;  IFF is the Amiga format using GEM compression
;
iff_count equ 48
IFF    struc
    dw 48
iff_chunk_id db 'FORM'
iff_id_len dw  0,0    ; file size - bytes are reversed
iff_ILBM  db 'ILBM'    ;
iff_BMHD  db 'BMHD'    ; bit mapped header
iff_bmhd_len dw 0,1400h ; length of header (reversed)
iff_width dw 0
iff_length dw 0
iff_x dw 0
iff_y dw 0
iff_no_planes db 1
iff_mask    db 1
iff_compr    db 1
iff_pad    db 0
iff_tcolor    dw 0
iff_aspect    db 1,1    ; 1 to 1 aspec ratio
iff_pagew    dw 4001h   ; st screen width and height
iff_pagel    dw 0c800h
iff_cmap    db 'CMAP'
iff_cmap_len  dw 0,0600h ; length of color map
iff_colors    db 0ffh,0ffh,0ffh,0,0,0
iff_body    db 'BODY'
iff_bod_len   dw  0,0    ; length of data following - have to fill in
  ; iff data follows
; other thigs to be found are: longer color maps and CRNG areas
; file sould be all right up to iff_colors
IFF   ends
;
;
;
;  TRY is a method for a best guess on file type
;
try_count equ 3
TRY    struc
    dw 3
try_sig   db 0,0,0
TRY    ends
;
;
;    PIG (PIXEL IMAGE GENERATION) HEADER
;
PIG_COUNT equ 18    ;NUMBER OF BYTES IN HEADER
PIG    STRUC
    DW    18    ;NUMBER OF BYTES IN HEADER
PIG_SOH    DB    1    ;START OF HEADER
PIG_MODE1    DB    0
PIG_MODE2    DB    0
PIG_DENSITY    DB    '000'    ;DOTS PER INCH
PIG_WIDTH    DB    '0000'    ;WIDTH OF IMAGE
PIG_HEIGHT    DB    '00000'    ;HEIGHT OF IMAGE
PIG_SPARE    DB    0,0
PIG_STX    DB    2    ;START OF TEXT
PIG    ENDS
;
;    IMG (IMAGE) HEADER
;
IMG_COUNT    equ    44
IMG    STRUC
    DW    44
IMG_NAME    DB    'FILE GENERATED FROM OPTIKS    '
IMG_HEIGHT    DW    0
IMG_WIDTH    DW    0
IMG_WIDTH_BYTE DW    0
IMG_PIX_SIZE   DW    1
IMG_PIX_FMT    DW    0
IMG_COLOR    DW    0
IMG_COMPRESS   DW    0
IMG    ENDS
;
;    MSP (MICRO SOFT PAINT) HEADER
;
MSP_COUNT    equ    32
MSP    STRUC
    DW  32
MSP_NAME    DB    'DanM'
MSP_WIDTH    DW    0
MSP_HEIGHT    DW    0
    DB    0EH,00H,0EH,00H,05H,00H,06H,00H
MSP_WIDTH1    DW    0
MSP_HEIGHT1    DW    0
    DB    0,0,0,0,29H,2CH,38H,1,4CH,0,0,0
MSP    ENDS
;
;    PGA HEADER
;
PGA_COUNT    equ    6
PGA    STRUC
    DW    6
PGA_WIDTH    DW    0
PGA_HEIGHT    DW    0
    DW    0
PGA    ENDS
;
;
;    GEM HEADER
;
GEM_COUNT    equ    16
GEM    STRUC
    DW    16    ; length of header
    db    0,1    ; version id
gem_ver    db    0,8    ; gem version id
gem_planes    dw    100h  ; number of color planes
gem_pattern    dw    200h  ; bytes in a pattern run
gem_psize  db    0,55h ; pixel size
    db    0,55h
GEM_WIDTH_pix  DW    0    ; width in pixels
GEM_HEIGHT    DW    0    ; heigth in lines
GEM    ENDS
; gem lines start with line width and then the count of bytes
; gem lines are xored
;
;
;    CUT HEADER
;
CUT_COUNT    equ    6
CUT    STRUC
    DW   6
CUT_WIDTH    DW    0
CUT_HEIGHT    DW    0
    DW    0
CUT    ENDS
;
;
;    BAS HEADER
;
BAS_COUNT    equ    7
BAS    STRUC
    DW  7
bas_tag    db    0fdh
BAS_vbase    DW    0b800h
BAS_offset    DW    0
BAS_size    DW    4000h
BAS    ENDS
;
;
;    PC PAINT+ HEADER
;
PCP_COUNT    equ    7
PCP    STRUC
    DW    7
PCP_tag    db    0fdh
PCP_vbase    DW    0b800h
PCP_offset    DW    0
PCP_size    DW    4000h
PCP    ENDS
;
;    PIC HEADER 1.50
;
PIC_COUNT    equ    16
PIC    STRUC
    DW    16
PIC_FH    DB    0FEH
PIC_SEG    DW    0B800H
PIC_OFF    DW    0
PIC_SIZE    DW    0    ;0,16384,32768
PIC_UNPACK    DW    16384
PIC_BLOCKS    DW    0
PIC_PAC_SZ    DW    0    ;NUMBER OF PACKED BYTES IN BLOCK
PIC_NORM    DW    0    ;NUMBER OF BYTES UNPACKED
PIC_ID    DB    0    ;IDENTIFIER
PIC    ENDS
;
;    RAS HEADER
;
RAS_COUNT    equ    0
RAS    STRUC
    DW    0
RAS    ENDS
;
;
;    DCOPY HEADER
;
DCOPY_COUNT    equ    512
DCOPY    STRUC
    DW    512
DCOPY_FH    DW    0FFFFH
DCOPY_ulx    DW    0    ; x and y of upper left
dcopy_uly    dw    0    ;
dcopy_height_pix dw    0    ; lines
DCOPY_width_bytes DW    0    ; bytes per line
dcopy_comp    dw    0    ; should be zero if not compressed
    dw    0    ; upper left in bits
dcopy_width_pix  dw    0
    dw    0    ; release
    dw    200  ; density
;    db    492 dup(0)  ; dcopy filler - nulls
DCOPY    ENDS

;
;PC paint version 2.0
;
pc2_count    equ    19
PC2 struc
    dw    19
PC2_PAGE    DW    1234H    ;START OF PAGE
PC2_PIX    DW    0    ;WIDTH OF IMAGE
PC2_HEIGHT    DW    0    ;HEIGHT OF IMAGE
PC2_X_OFF    DW    0    ;X OFFSET OF PC2
PC2_Y_OFF    DW    0    ;Y OFFSET OF PC2
PC2_PIX_SIZE   DB    1    ;SIZE OF PEL
PC2_2    DB    0FFH    ;PCPAINT 2.0
PC2_MODE    DB    'E'    ;TYPE OF DISPLAY
PC2_DESC    DW    0    ;DESCRIPTOR
PC2_COUNTer    DW    0    ;COUNT
PC2_BLOCK    DW    1    ;NUMBER OF PACKED BLOCKS
pc2 ends
;
;    pc2 PACket
;
;PAC_HEADER   equ this word
;PC2_PAC_SZ    DW    0    ;NUMBER OF PACKED BYTES IN BLOCK
;PC2_NORM    DW    0    ;NUMBER OF BYTES UNPACKED
;PC2_ID    DB    0    ;IDENTIFIER
;
;RLE
;
RLE_count    equ    3
RLE struc
    dw    3
RLE_esc    Db    27    ;escape character
RLE_G    Db    'G'    ;graphics indicator
RLE_Density    DW    'H'    ;densityr, H=high, M= medium
RLE ends
;
;    MAC HEADER
;

MAC_COUNT    equ    128
MAC    STRUC
    DW    640
MAC_VERSION    DB    0
MAC_LEN_FN    DB    6
MAC_FILE_NAME  DB    'OPTIKS'
    DB    57 DUP(0)
MAC_FILE_TYPE  DB    'PNTG'
MAC_FILE_CREAT DB    'MPNT'
MAC_FLAGS    DB    1
MAC_FILL1    DB    0
MAC_VERT    DW    0
MAC_HORIZ    DW    0 ;8001H
MAC_FOLDER    DW    0
MAC_PROT    DB    0
MAC_FILL2    DB    0
MAC_FORK    DD    0
MAC_R_FORK    DD    0
MAC_CRT_DATE   DB    9BH,41H,8CH,0FAH
MAC_LST_MOD    DB    9BH,41H,8CH,0FEH
MAC_FILL3    DB    27 DUP(0)
MAC_OS    DW    0
MAC    ENDS

MAC1    STRUC
MAC_REV    DB    0,0,0,2
MAC_PAT_01    DB    0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
    db    56 dup(0)
;MAC_PAT_02    DB    0DDH,0FFH,077H,0FFH,0FFH,077H,0FFH,0DDH
;MAC_PAT_03    DB    077H,0DDH,077H,0DDH,077H,0DDH,077H,0AAH
;MAC_PAT_04    DB    055H,0AAH,055H,0AAH,055H,0AAH,055H,055H
;MAC_PAT_05    DB    0FFH,055H,0FFH,055H,0FFH,055H,0FFH,0AAH
;MAC_PAT_06    DB    0AAH,0AAH,0AAH,0AAH,0AAH,0AAH,0AAH,0EEH
;MAC_PAT_07    DB    0DDH,0BBH,077H,0EEH,0DDH,0BBH,077H,088H
;MAC_PAT_08    DB    088H,088H,088H,088H,088H,088H,088H,0B1H
MAC1    ENDS
MAC2    STRUC
    db    64 dup(0)
;MAC_PAT_09    DB    030H,003H,01BH,0D8H,0C0H,00CH,08DH,080H
;MAC_PAT_10    DB    010H,002H,020H,001H,008H,040H,004H,0FFH
;MAC_PAT_11    DB    088H,088H,088H,0FFH,088H,088H,088H,0FFH
;MAC_PAT_12    DB    080H,080H,080H,0FFH,008H,008H,008H,080H
;MAC_PAT_13    DB    000H,000H,000H,000H,000H,000H,000H,080H
;MAC_PAT_14    DB    040H,020H,000H,002H,004H,008H,000H,082H
;MAC_PAT_15    DB    044H,039H,044H,082H,001H,001H,001H,0F8H
;MAC_PAT_16    DB    074H,022H,047H,08FH,017H,022H,071H,055H
MAC2    ENDS
MAC3    STRUC
    db    64 dup(0)
;MAC_PAT_17    DB    0A0H,040H,040H,055H,00AH,004H,004H,020H
;MAC_PAT_18    DB    050H,088H,088H,088H,088H,005H,002H,0BFH
;MAC_PAT_19    DB    000H,0BFH,0BFH,0B0H,0B0H,0B0H,0B0H,000H
;MAC_PAT_20    DB    000H,000H,000H,000H,000H,000H,000H,080H
;MAC_PAT_21    DB    000H,008H,000H,080H,000H,008H,000H,088H
;MAC_PAT_22    DB    000H,022H,000H,088H,000H,022H,000H,088H
;MAC_PAT_23    DB    022H,088H,022H,088H,022H,088H,022H,0AAH
;MAC_PAT_24    DB    000H,0AAH,000H,0AAH,000H,0AAH,000H,0FFH
MAC3    ENDS
MAC4    STRUC
    db    64 dup(0)
;MAC_PAT_25    DB    000H,0FFH,000H,0FFH,000H,0FFH,000H,011H
;MAC_PAT_26    DB    022H,044H,088H,011H,022H,044H,088H,0FFH
;MAC_PAT_27    DB    000H,000H,000H,0FFH,000H,000H,000H,001H
;MAC_PAT_28    DB    002H,004H,008H,010H,020H,040H,080H,0AAH
;MAC_PAT_29    DB    000H,080H,000H,088H,000H,080H,000H,0FFH
;MAC_PAT_30    DB    080H,080H,080H,080H,080H,080H,080H,008H
;MAC_PAT_31    DB    01CH,022H,0C1H,080H,001H,002H,004H,088H
;MAC_PAT_32    DB    014H,022H,041H,088H,000H,0AAH,000H,040H
MAC4    ENDS
MAC5    STRUC
    db    48 dup(0)
;MAC_PAT_33    DB    0A0H,000H,000H,004H,00AH,000H,000H,003H
;MAC_PAT_34    DB    084H,048H,030H,00CH,002H,001H,001H,080H
;MAC_PAT_35    DB    080H,041H,03EH,008H,008H,014H,0E3H,010H
;MAC_PAT_36    DB    020H,054H,0AAH,0FFH,002H,004H,008H,077H
;MAC_PAT_37    DB    089H,08FH,08FH,077H,098H,0F8H,0F8H,000H
;MAC_PAT_38    DB    008H,014H,02AH,055H,02AH,014H,008H,000H
MAC_FILL4    DB    204 DUP(0)
MAC5    ENDS
;
;
;    PCR HEADER
;
PCR_COUNT    equ    10
PCR    STRUC
    DW    10
PCR_kpg    Db    'KPG'
PCR_vers    DW    0100h
pcr_rec10    db    10h
pcr_10_len    dw    0,0
pcr_name    db    128 dup(0)
pcr_data_head  db    12h
pcr_fcount    dw    0
pcr_fcount1    dw    0
pcr_crc_in    dw    0
pcr_x_in    dw    0
pcr_y_in    dw    0
PCR    ENDS
;
;
;DCX library type PCX files used to store fax in panasonic
DCX_count    equ    256
DCX struc
    dw    256
    db  256 dup(0)
DCX ends
;
;
;
;PCB PC paintbrush
;
PCB_count    equ    128
PCB struc
    dw    128
PCB_BEG    db    0ah,02,01
PCB_BITS_PER_PIXEL db 01
PCB_X    dw    0    ;left pos in bits
PCB_Y    dw    0    ;left y in bits
PCB_LR_X    dw    0    ; right x in bits
PCB_LR_Y    dw    0    ; right y in bits
PCB_hres    dw    640
PCB_vres    Dw    200

PCB_COLORS    db    0,0,27h
    db    0,0,27h
    db    0,0,27h
    db    0,0,27h
    db    0,0,27h
    db    0,0,27h
    db    0,0,27h
    db    0,0,27h
    db    0,0,27h
    db    0,0,27h
    db    0,0,27h
    db    0,0,27h
    db    0,0,27h
    db    0,0,27h
    db    0,0,27h
    db    0,0,27h
    db    0
PCB_NUM_PLANES db    1
PCB_WIDTH_BYTES dw    80
    db    0,0,0ddh,03
    db    56  dup(0)
PCB ends
;
;
;
;GIF Compuserve Graphics Interchange Format
;
GIF_count    equ    13
GIF struc
    dw    13
GIF_SIG    db    'GIF'
GIF_VER    db    '87a'
; screen descriptor
GIF_screen_width   dw 640
GIF_screen_length  dw 200
GIF_DESC    db    00000000b ; broken down
GIF_back    db    0    ;background color
    db    0    ;un used
GIF ends
;
;    DGI HEADER
;
DGI_COUNT    equ    6
DGI    STRUC
    DW    6
DGI_WIDTH    DW    0
DGI_HEIGHT    DW    0
    DW    0
DGI    ENDS
;
;
;    TXT HEADER
;
TXT_COUNT    equ    0
TXT    STRUC
    DW    0
    DW    0
TXT    ENDS
;
;
;    123 HEADER
;
LOT_COUNT    equ    17
LOT    STRUC
    Dw    17
LOT_SIG    DB    1,0,0,0,1,0,8,0,44H,0,0,0,0,0CH,7FH,9,6
LOT    ENDS
;
;
;    HPGL HEADER
;
HPG_COUNT    equ    0
HPG    STRUC
    DW    0
HPG    ENDS
;
;
;
;    TIFF HEADER
TIF_COUNT    equ    10
TIF    STRUC
    DW    10
;
;The following are data areas and constants for TIFF formats
tif_head  dw    4949h    ;II, swapped byte order, INTEL default
tif_vers dw    02ah    ;Version = 42 (See hitchiker's guide to the universe)
    dw    8,0    ;byte offset to next entity

    dw    12    ;count of directory entries
TIF    ENDS


;
;    ISF  HEADER
;
ISF_COUNT    equ    6
ISF    STRUC
    DW    6
; this is the name of the picture
ISF_segment    db    70h
ISF_s_length   db    4
isf_s_name    db    "OK20"
;
ISF    ENDS
;
;   RAW files are files which can be put into basic arrays
;
RAW_COUNT    equ    4
RAW    STRUC
    DW    4
RAW_WIDTH    DW    0   ; bits
RAW_HEIGHT    DW    0   ; bits
RAW    ENDS
;
;
;   ART files are PFS first publisher ART files
;
ART_COUNT    equ    8
ART    STRUC
    DW    8
ART_X    DW    0   ; bits
ART_WIDTH    DW    0   ; bits
ART_Y    DW    0   ; bits
ART_HEIGHT    DW    0   ; bits
ART    ENDS
;
;
;   NWS Newsroom pro
;
NWS_COUNT    equ    32
NWS    STRUC
    DW    32
NWS_T    DB    'T' ; ident
NWS_SIZE    DW    0
    db    12 dup(0)
NWS_top    DW    0
NWS_bot    DW    0   ; bits
NWS_left    DW    0
NWS_right    DW    0   ; bits
NWS    ENDS
;
;
;   DEG files are ATARI DEGAS files
;
DEG_COUNT    equ    32
DEG    STRUC
    DW    32
DEG_MODE    DW    0   ; bits
    DW    15 DUP(0)  ;PALLETTE
DEG    ENDS
;
;
;
;    PCR FONT
;
FNT_COUNT    equ    10
FNT    STRUC
    DW    10
FNT_kpg    Db    'KPG'
FNT_vers    DW    0201h
FNT_rec20    db    20h
FNT_20_len    dw    0,0
FNT    ENDS
;
;
;
;    POSTSCRIPT FILE
;
POS_COUNT    equ    2
POS    STRUC
    DW    2
    db    '%!'
POS    ENDS
;
;
;
;    F01 FAX FILE
;
F01_COUNT    equ    64
F01    STRUC
    DW    64
F01_data    DB    64 dup(0)
F01    ENDS
;
;
;    CBM DOODLE
;
DOO_COUNT    equ    2
DOO    STRUC
    DW    2
DOO_data    DB    2  dup(0)
DOO    ENDS
;
;
; soft font
;
SFP_COUNT equ  3
SFP    STRUC
    DW  3
SFP_ESC    db  1bh    ; escape character
SFP_code   db  ")s"    ; indicates a soft font
SFP    ENDS
;
;
; soft font letter
;
SFL_COUNT equ  31
SFL    STRUC
    DW  31
    db  1bh    ; escape character
    db  "*c"    ; set character code
SFL_ascii  db  '000'   ; ascii character in decimal
    db  'E'    ; end of  ascii
    db  1bh    ; escape character
    db  "(s"    ; indicates a download letter
SFL_length db  "0000"   ; decimal length of data after W
    db  "W"    ; start of data
    db  4,0,14,1;fill
SFL_orient db  0    ; 0 = portrait, 1 = landscape
    db  0    ; fill
; word values are msb first
SFL_left   dw  0    ; left offset to start of box
SFL_top    dw  0    ; height above origin of character
SFL_width  dw  0    ; character width in dots
sfl_height dw  0    ; total height of character - lines of data
SFL_deltax dw  0    ; horizontal motion after printing *4
SFL    ENDS
;
;
PRT_COUNT equ 0
PRT    STRUC
    DW 0
    DB 0
PRT    ENDS
;
