; OKFONTS.ASM
;
; this has the code to load fonts. You can find the select fonts
; in OKCHAR
;
include f:okfiles.asm
;
;
;  LSEG is the logo segment
;
lseg segment public 'DATA'
assume ds:lseg,es:lseg
extrn font0:byte,font1:byte,font2:byte
extrn logo:byte
font3 equ byte ptr logo
font4 equ byte ptr logo+3585
lseg ends
;
dseg segment  public 'DATA'
;
assume cs:cseg,ds:dseg,es:dseg
extrn handle:word,font:word
extrn curx:word,cury:word,left_margin:word
extrn buffer:word
extrn FNT_HEADER:byte
;
; local data
;
cur_font  dw  0
fonts  dw font0,font1,font2,font3,font4
font_in dw  1
public font_in
;
dseg ends
;
;
;
cseg segment  public 'CODE'
assume cs:cseg,ds:dseg,es:dseg
extrn say_enter_file:near,present:near,open_in:near,close_file:near
extrn do_wait:near,reset_segs:near
extrn getkey:near,goback:near,read_file:near
;
font_get proc near
;
FNT_IN:   ; input routine for checking font header
public FNT_IN
     call  reset_segs
     mov  bx,font_in
     mov  cur_font,bx
; have to check the various parts of the header
; check to see if it is us
       cmp  fnt_header.fnt_kpg,'K'
       jne  bad_head
       cmp  fnt_header.fnt_kpg+1,'P'
       jne  bad_head
       cmp  fnt_header.fnt_kpg+2,'G'
       jne  bad_head
       cmp  fnt_header.fnt_vers,0201h
       jg   bad_head
       cmp  fnt_header.fnt_rec20,20h
       jne   bad_head
       mov   cx,fnt_header.fnt_20_len
       cmp   cx,3585
       jg    bad_head
       clc
       ret
bad_head:
       stc
       ret
FNT_READ:
public FNT_READ
    call reset_segs
       mov   cx,fnt_header.fnt_20_len
       mov   bx,cur_font
       shl   bx,1
       mov   dx,fonts[bx]
       push  ds
       mov   ax,lseg
       mov   ds,ax
       call  read_file
       pop   ds
       stc
       ret
font_get   endp
CSEG	ENDS
	END
